import logging


from . import api
from .records import create_records, Agent


logger = logging.getLogger(__name__)


@create_records(Agent)
def get_all():
    """ Get all Agents from the PPA Appliance.

    :raises exceptions.PermissionDenied: if the user who triggered the task does not have the required permissions.

    :returns: A list of :ref:`agents:Agent Records`.

    Example:

        .. code-block:: python

            agents.get_all()
    """
    return api.get(api_type="rest", endpoint="agents")
