from ppa_tools.control_flow import exception_translate


class ParameterError(Exception):
    pass


class ApiRequestError(TypeError):
    pass


class ServerError(Exception):
    pass


class PermissionDenied(Exception):
    pass


class NoSuchObject(Exception):
    pass


def raise_on_empty(exception_msg):
    return exception_translate({IndexError: NoSuchObject(exception_msg)})


def reraise_with_context(exception, exception_msg):
    return exception_translate({exception: exception(exception_msg)})
