from typing import List, Union

from ppa_api import tasks, exceptions

from .records import Task, TaskData


def get_all() -> List[Task]:
    return [TaskData(**task.__dict__).__dict__ for task in tasks.get_all()]


def get_by_uuid(uuid: str) -> Union[Task, None]:
    try:
        return TaskData(**tasks.get_by_uuid(uuid).__dict__).__dict__
    except exceptions.NoSuchObject:
        return None


def started_by_user(username: str) -> Union[List[Task], None]:
    return [TaskData(**task_object.__dict__).__dict__ for task_object in tasks.started_by_user(username)] or None
