from typing import List, Union

from ppa_api import users, exceptions

from .records import User, UserData


def get_all() -> List[User]:
    return [UserData(**user.__dict__).__dict__ for user in users.get_all()]


def get_by_id(user_id: Union[str, int]) -> Union[User, None]:
    try:
        return UserData(**users.get_by_id(user_id).__dict__).__dict__
    except exceptions.NoSuchObject:
        return None


def get_by_name(name: str) -> Union[User, None]:
    try:
        return UserData(**users.get_by_name(name).__dict__).__dict__
    except exceptions.NoSuchObject:
        return None


def deactivate_by_id(user_id: Union[str, int]) -> None:
    users.deactivate_by_id(user_id)


def activate_by_id(user_id: Union[str, int]) -> None:
    users.activate_by_id(user_id)


def deactivate_by_name(name: str) -> None:
    users.deactivate_by_name(name)


def activate_by_name(name: str) -> None:
    users.activate_by_name(name)
